# -*- coding:Utf-8 -*-


# ====================================================================================================
#
# >> IMPORTATIONS
#
# ====================================================================================================


import es
import langlib
import usermsg
import gamethread

import os

import psyco
psyco.full()


# ====================================================================================================
#
# >> INFORMATIONS
#
# ====================================================================================================


informations = es.AddonInfo()
informations.name = 'Easy Bunny Hopping'
informations.basename = 'easybhop'
informations.version = '1.0'
informations.author = 'L\'In20Cible'
informations.description = 'Provides a client command that allows to easily bunny hop.'
informations.url = 'http://addons.eventscripts.com/addons/view/easybhop/'

es.ServerVar('easybhop_version', informations.version + ' by ' + informations.author).makepublic()


# ====================================================================================================
#
# >> VARIABLES GLOBALES
#
# ====================================================================================================


players = list()


# ====================================================================================================
#
# >> INITIALISATION
#
# ====================================================================================================


def load():
    initialize()
    es.addons.registerTickListener(TickListenerCallBack)
    
def initialize():
    global translations
    translations = langlib.Strings(os.path.join(es.getAddonPath(informations.basename), 'configuration', 'translations.ini').replace(os.sep, '/'))
    
def unload():
    es.addons.unregisterTickListener(TickListenerCallBack)
    
    
# ====================================================================================================
#
# >> FONCTIONS D'APPEL
#
# ====================================================================================================


def TickListenerCallBack():
    for player in players:
        if es.getplayerprop(player, 'CBasePlayer.localdata.m_hGroundEntity') != -1:
            es.setplayerprop(player, 'CBasePlayer.localdata.m_vecBaseVelocity', '0,0,%f' % (300 + es.getplayerprop(player, 'CBasePlayer.localdata.m_Local.m_flFallVelocity')))
            
            
# ====================================================================================================
#
# >> VNEMENTS
#
# ====================================================================================================


def player_death(event_var):
    userid = int(event_var['userid'])
    if userid in players:
        players.remove(userid)
        
def player_disconnect(event_var):
    userid = int(event_var['userid'])
    if userid in players:
        players.remove(userid)
        
def client_keypress(event_var):
    if event_var['keyname'] == 'easybhop':
        userid = int(event_var['userid'])
        if int(event_var['status']) and userid not in players:
            players.append(userid)
        elif userid in players:
            players.remove(userid)
            
def player_activate(event_var):
    userid = int(event_var['userid'])
    if not es.isbot(userid):
        es.tell(userid, '#multi', '\x05[EasyBhop] \x01%s' % translations('player_activate', lang=langlib.getLangAbbreviation(es.getclientvar(userid, 'cl_language'))))
        
def player_spawn(event_var):
    userid = int(event_var['userid'])
    if not es.isbot(userid):
        gamethread.delayed(0.1, usermsg.hudhint, (userid, translations('player_spawn', lang=langlib.getLangAbbreviation(es.getclientvar(userid, 'cl_language')))))